#include <iostream>
using namespace std;
#define MAX 50

struct Pilha {
    int v[MAX];
    int topo;
};

int empilhar(Pilha &p, int valor) {
    // Verifica se a pilha est cheia
    if ( p.topo == MAX-1 ) return 1;
    // Se no est...
    p.topo = p.topo + 1;
    p.v[p.topo] = valor;
    return 0;
 /*
(p.topo==MAX-1)? return 1 : p.v[++p.topo]=valor, return 0;
*/
}

int desempilhar(Pilha &p, int &valor) {
    // Verificar se a pilha est vazia
    if ( p.topo == -1 ) return 1;
    // Se no est
    valor = p.v[p.topo];
    p.topo = p.topo - 1;
    return 0;
}

int main(void) {
    // Declarando e inicializando a pilha
    Pilha pilha;
    pilha.topo = -1;
    int tmp;

    empilhar(pilha, 3);
    empilhar(pilha, 5);

    while ( desempilhar(pilha, tmp) == 0) {
        cout << tmp << endl;
    }

}

